/* -*- c++ -*- */
/*
 * Copyright 2016 The Aerospace Corporation.
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_GOESSDR_MPC_DELAY_IMPL_H
#define INCLUDED_GOESSDR_MPC_DELAY_IMPL_H

#include <goessdr/mpc_delay.h>
#include <pmt/pmt.h>

namespace gr {
  namespace goessdr {

    class mpc_delay_impl : public mpc_delay
    {
    private:
      void forecast(int noutput_items,
                    gr_vector_int &ninput_items_required);

      size_t d_itemsize;
      int d_delta;
      gr::thread::mutex d_mutex_delay;

    public:
      mpc_delay_impl(size_t itemsize, int delay);
      ~mpc_delay_impl();

      int dly() const { return history()-1; }
      void set_dly(int d);

      int general_work(int noutput_items,
                       gr_vector_int &ninput_items,
                       gr_vector_const_void_star &input_items,
                       gr_vector_void_star &output_items);
                       
      void set_dly_from_msg(pmt::pmt_t msg);
    };

  } // namespace goessdr
} // namespace gr

#endif /* INCLUDED_GOESSDR_MPC_DELAY_IMPL_H */

