from LritReceiver import LritReceiver
import numpy
import timeit
import logging
import logging.config
import yaml

def configureLogger():
   with open('config.yaml','r') as configFile:
      try:
         config = yaml.load(configFile)
         logging.config.dictConfig(config['logging'])
      except yaml.YAMLError as yerr:
         print(yerr)
   logger = logging.getLogger(__name__)
   return logger

logger = configureLogger()
#CADU_CODEWORD_LENGTH = 1024
VCDU_CODEWORD_LENGTH = 1020

#codewordFile = open("lrit1Min_ascii.txt")
#codewords = [int(x) for x in codewordFile.readlines()]
#print(len(codewords))
codewords = numpy.fromfile("HamletUpToVCDU.dat",dtype=numpy.uint8).tolist()
print(len(codewords))

TEST_COUNT = 100

def testFunc():
   lritReceiver = LritReceiver()
   for j in range(0,TEST_COUNT):
      for codeword in [codewords[i:(i+VCDU_CODEWORD_LENGTH)] for i in range(0,len(codewords),VCDU_CODEWORD_LENGTH)]:
#         codeword[10] += 1
#         codeword[10 + 223] += 1
#         codeword[10 + 2*223] += 1
#         codeword[10 + 3*223] += 1
         lritReceiver.rx(codeword)
   del lritReceiver

print(timeit.timeit("testFunc()",number=1,setup="from __main__ import testFunc"))

